//+------------------------------------------------------------------+
//|                                               Multi_EA_2.0.5.mq4 |
//|                                                         hellkkas |
//|                                    mailto:helderkastro@gmail.com |
//+------------------------------------------------------------------+

// Version 2.0 - May 27th, 2007
// Modifications by FerruFx:
// 1. MagicNumber added: EA can be use now with others EAs on the same platform
// 2. Unique version for all type of account (IBFXmini and others)
// Last modifications by dmbsys - May 30th, 2007 - Ver. 2.0.5
// -. Decision with RSX(3) on H4

#property copyright "hellkkas"
#property link      "mailto:hellkkas@gmail.com"

//---- input parameters
extern bool     AccountIsIBFXmini=false;
extern double   Lots=0.1;
extern double   MaximumRisk=0.03;
extern double   DecreaseFactor=300;
extern double   MinLot=0.1;
extern int      Slippage=3;
extern double   TrailingStop=30;
double          StartBalance,StartEquity;
extern bool     UseHourTrade = false;
extern int      FromHourTrade = 6;
extern int      ToHourTrade = 18;
extern int      ParamInd = 3;
extern int      ShiftValue = 0;
extern int      ReverseCondition = 0;

//---- global variables
int             bsi=0;
int             dir=0;
int             vTrig=0;
int             openorders=0;
int             cnt;
string          pair;
int             MagicNumber;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") { MagicNumber = 427101; }
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") { MagicNumber = 427102; }
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") { MagicNumber = 427103; }
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") { MagicNumber = 427104; }
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") { MagicNumber = 427105; }
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") { MagicNumber = 427106; }
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") { MagicNumber = 427107; }
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") { MagicNumber = 427108; }
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") { MagicNumber = 427109; }
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") { MagicNumber = 427110; }
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") { MagicNumber = 427111; }
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") { MagicNumber = 427112; }
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") { MagicNumber = 427113; }
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") { MagicNumber = 427114; }
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") { MagicNumber = 427115; }
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") { MagicNumber = 427116; }
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") { MagicNumber = 427117; }
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") { MagicNumber = 427118; }
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") { MagicNumber = 427119; }
   if (MagicNumber == 0) { MagicNumber = 427199; }
   
   pair = Symbol();
   
   return(0);
  } 

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int GetCurrentOrders()
  {
  //---- calc open OrderSelect
   openorders=0;
   dir=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
        openorders+=1;
        if(OrderType()==OP_BUY) dir=1;
        if(OrderType()==OP_SELL) dir=-1;
      }  
   }
}
//+-------------------End Calculate open positions-------------------+
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/500.0,1);
//---- calculate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MagicNumber || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<MinLot) lot=MinLot;
   return(lot);
  }
//+-------------------End Calculate optimal lot size-----------------+
//+------------------------------------------------------------------+
//| Close Open Position                                              |
//+------------------------------------------------------------------+
int CloseTrade()
  { 
  for(int i=0;i<OrdersTotal();i++)
    {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
        if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,3,Yellow);
        if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,3,Yellow);
      }  
   }
}
//+----------------------End Close Open Position---------------------+
//+------------------------------------------------------------------+
//| Open Trade Position                                              |
//+------------------------------------------------------------------+
int OpenTrade()
  {
   int vLots=LotsOptimized();
   if (bsi>0) OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage,0,0,"JRSXsys205",MagicNumber,0,Green);
   
   if (bsi<0) OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage,0,0,"JRSXsys205",MagicNumber,0,Red);
}
//+----------------------End Open Trade Position---------------------+
//+------------------------------------------------------------------+
//| Buy/Sell Indicator                                               |
//+------------------------------------------------------------------+
int CalcBSI()
  {
  //---- calc current indicators
  string gbpusd, eurusd, usdchf;
  if(AccountIsIBFXmini == true) { gbpusd = "GBPUSDm"; eurusd = "EURUSDm"; usdchf = "USDCHFm"; }
  if(AccountIsIBFXmini == false) { gbpusd = "GBPUSD"; eurusd = "EURUSD"; usdchf = "USDCHF"; }
  
  int GU_Trig=1,EU_Trig=1,UC_Trig=1,UJ_Trig=1;
  if (iCustom(gbpusd,0,"RSX",ParamInd,0,ShiftValue)<50)GU_Trig=-1;
  if (iCustom(eurusd,0,"RSX",ParamInd,0,ShiftValue)<50)EU_Trig=-1;
  if (iCustom(usdchf,0,"RSX",ParamInd,0,ShiftValue)<50)UC_Trig=-1;
  vTrig=GU_Trig+EU_Trig-UC_Trig;

  bsi=0;
  if (vTrig>2) bsi=1;
  if (vTrig<-2) bsi=-1;
  if (pair>"USD") bsi=bsi*(-1);
  
  if (ReverseCondition==0) bsi = bsi;
  if (ReverseCondition==1) bsi = -bsi;

}
//+-----------------------End Buy/Sell Indicator---------------------+
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
 
 //if (Period()!=PERIOD_H4) { Alert("Only on H4 !"); return(0); } // For use only on H4 --- NO ERROR if activated
 
  for(cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  // check for symbol and magic number
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
          
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
//+--------------------End TrailingStop & BreakEven------------------+
if (UseHourTrade)
   {
   if (!((Hour() >= FromHourTrade) && (Hour() <= ToHourTrade)))
      {
      Comment("Non-Trading Hours!");
      return(0);
      }
   }

  GetCurrentOrders();
  CalcBSI();
  Comment("\nStart Balance= ",StartBalance,",","Start Equity= ",StartEquity,
		   "\nBalance: ",AccountBalance(),","," Equity: ",AccountEquity(),","," TotalProfit: ",AccountProfit(),
         "\nDir: ",dir,"\nBSI: ",bsi,"\nTrig: ",vTrig);
   
  //---- exit trades
  if (openorders!=0) {
     if ((bsi>0) && (dir<0)) CloseTrade();
     if ((bsi<0) && (dir>0)) CloseTrade();
  }   
  //---- open trades
  else {
   if (bsi!=0) OpenTrade();
  }   
}
//+---------------------End Expert Start Function--------------------+